//  Torry's Delphi Pages
//  http://www.swissdelphicenter.ch/torry/showcode.php?id=1177

//  Windows NT ñVXeł́A^ȂƎgȂ֐
//  ܂BƂ΁AExitWindowsEx gpVXẽVbg_
//  EċNAVXe̕ύXȂǂłB
//  ȉ̃R[h́A𒲐邽߂̊֐łB
//  AdjustTokenPrivileges() ́Aw肵ANZXg[N(?)ŁA
//  ^肵܂B

unit NTPrivilege;

interface

uses
    Windows, SysUtils;


//  NT Defined Privileges from winnt.h
//  winnt.h Œ`Ă錠
const
    SE_CREATE_TOKEN_NAME = 'SeCreateTokenPrivilege';
    SE_ASSIGNPRIMARYTOKEN_NAME = 'SeAssignPrimaryTokenPrivilege';
    SE_LOCK_MEMORY_NAME = 'SeLockMemoryPrivilege';
    SE_INCREASE_QUOTA_NAME = 'SeIncreaseQuotaPrivilege';
    SE_UNSOLICITED_INPUT_NAME = 'SeUnsolicitedInputPrivilege';
    SE_MACHINE_ACCOUNT_NAME = 'SeMachineAccountPrivilege';
    SE_TCB_NAME = 'SeTcbPrivilege';
    SE_SECURITY_NAME = 'SeSecurityPrivilege';
    SE_TAKE_OWNERSHIP_NAME = 'SeTakeOwnershipPrivilege';
    SE_LOAD_DRIVER_NAME = 'SeLoadDriverPrivilege';
    SE_SYSTEM_PROFILE_NAME = 'SeSystemProfilePrivilege';
    SE_SYSTEMTIME_NAME = 'SeSystemtimePrivilege';
    SE_PROF_SINGLE_PROCESS_NAME = 'SeProfileSingleProcessPrivilege';
    SE_INC_BASE_PRIORITY_NAME = 'SeIncreaseBasePriorityPrivilege';
    SE_CREATE_PAGEFILE_NAME = 'SeCreatePagefilePrivilege';
    SE_CREATE_PERMANENT_NAME = 'SeCreatePermanentPrivilege';
    SE_BACKUP_NAME = 'SeBackupPrivilege';
    SE_RESTORE_NAME = 'SeRestorePrivilege';
    SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';
    SE_DEBUG_NAME = 'SeDebugPrivilege';
    SE_AUDIT_NAME = 'SeAuditPrivilege';
    SE_SYSTEM_ENVIRONMENT_NAME = 'SeSystemEnvironmentPrivilege';
    SE_CHANGE_NOTIFY_NAME = 'SeChangeNotifyPrivilege';
    SE_REMOTE_SHUTDOWN_NAME = 'SeRemoteShutdownPrivilege';
    SE_UNDOCK_NAME = 'SeUndockPrivilege';
    SE_SYNC_AGENT_NAME = 'SeSyncAgentPrivilege';
    SE_ENABLE_DELEGATION_NAME = 'SeEnableDelegationPrivilege';
    SE_MANAGE_VOLUME_NAME = 'SeManageVolumePrivilege';

//-----------------------------------------------------------------------------
//  ̕t^Ǝ
function NTSetPrivilege(sPrivilege: string; bEnabled: Boolean): Boolean;

implementation

//-----------------------------------------------------------------------------
//  ̕t^Ǝ
function NTSetPrivilege(sPrivilege: string; bEnabled: Boolean): Boolean;
var
    hToken: THandle;
    TokenPriv: TOKEN_PRIVILEGES;
    PrevTokenPriv: TOKEN_PRIVILEGES;
    ReturnLength: Cardinal;
begin
    //  Windows NT/2000/XP ȍ~łȂƈӖȂ
    Result := True;
    if not (Win32Platform = VER_PLATFORM_WIN32_NT) then Exit;

    //  vZXg[N擾
    if OpenProcessToken(GetCurrentProcess(),
        TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
    begin
        try
            //  locally unique identifier (LUID) 擾
            if LookupPrivilegeValue(nil, PChar(sPrivilege),
                                    TokenPriv.Privileges[0].Luid) then
            begin
                //  one privilege to set
                TokenPriv.PrivilegeCount := 1;

                //  t^邽߂̐ݒ
                if (bEnabled) then
                begin
                    TokenPriv.Privileges[0].Attributes  := SE_PRIVILEGE_ENABLED;
                end

                //  ߂̐ݒ
                else
                begin
                    TokenPriv.Privileges[0].Attributes := 0;
                end;

                //  replaces a var parameter
                ReturnLength := 0;
                PrevTokenPriv := TokenPriv;

                //  Kp
                AdjustTokenPrivileges(hToken, False, TokenPriv, SizeOf(PrevTokenPriv),
                                        PrevTokenPriv, ReturnLength);
            end;
        finally
            CloseHandle(hToken);
        end;
    end;

    //  AdjustTokenPrivileges() ̐
    Result := GetLastError = ERROR_SUCCESS;
end;

end.
 